//#include "lists.h"
#include <iostream>
#include <vector>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>
#include <pybind11/eigen.h>
#include <Eigen/Dense>

using Eigen::MatrixXd;
using Eigen::VectorXd;

using namespace std;
namespace py=pybind11;


MatrixXd add_one(MatrixXd mat)
{
    auto ret = mat + MatrixXd::Constant(mat.rows(), mat.cols(), 1.0);
    return ret;
}

MatrixXd multiply_by_scalar(const MatrixXd& mat, float scalar)
{
    return scalar * mat;
}

MatrixXd add_row(const MatrixXd& mat, const VectorXd& v) {
    return (mat.rowwise() + v.transpose());
}

void funcioncitah(){

    // Incializando matrices

    // m de 4x4, con coeficientes no inicializados
    MatrixXd M(4,4);

    M << 1,0,0,0,
         0,2,0,0,
         0,0,3,0,
         0,0,0,4;
         
    cout << "M es de " << M.rows() << "x" << M.cols() << endl;
    cout << M << endl;

    // v de 4x1, vector de unos
    VectorXd v(4);
    v << 1,1,1,1;  
    cout << "V:" << endl << v << endl;

    // Algo de Multiplicacion de Matrices

    cout << "M.M :" << endl << M*M << endl;
    cout << "M.v :" << endl << M*v << endl;
    cout << "vt.M :" << endl << v.transpose()*M << endl;
    cout << "producto interno!" << endl << v.dot(v) << " o bien " << v.transpose()*v<< endl;

    // Y esto que hace?? :o 

    MatrixXd::Index index;
    (M.rowwise() - v.transpose()).rowwise().squaredNorm().minCoeff(&index);
    cout << "Uhm? " << index << endl;
}