import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
from classifier.knn import knn
from classifier.auxiliars import *
from classifier.bag_of_words import BagWordModels

df_train = load_df_train()

df_by_genre = { g: df_train[df_train["Genre"] == g] for g in GENRES }

class_size = len(df_by_genre["western"]) // 5
classes = [
    pd.concat([df_by_genre[g].iloc[class_size * i : class_size * (i + 1)] for g in GENRES])
    for i in range(5)
]

x_test = classes.pop(0)
x_train = pd.concat(classes)

K = 5

for Q in [500, 1000, 5000]:
    datamodel = BagWordModels(df_train, Q)

    knn_result = knn(x_test, x_train, K, datamodel)

    print("Q: ", Q)
    print(knn_result)
    print("")